/*******************************************************************
*
*  DESCRIPTION: counter Model
*
*  AUTHOR: SHAGUN GOEL
*
*
*  
*
*******************************************************************/

#ifndef __counter_H
#define __counter_H

#include "atomic.h"     // class Atomic

/** forward declarations **/
class Distribution ;

class counter : public Atomic
{
public:
	counter( const string &name = "counter" );	//Default constructor
	~counter ();

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &in;
	const Port &beReady;
	Port &out;
	Port &request;
	//Time delayTime;
	int myId;  // The id of this counter.
	double value;
	bool ready;
	Distribution *dist ;

	Distribution &distribution()
			{return *dist;}	
};	// class counter

// ** inline ** // 
inline
string counter::className() const
{
	return "counter" ;
}

#endif   //__counter_H
